#include <windows.h>
#include <commctrl.h>
#include <math.h>
#include <stdio.h>
#include "resource.h"
#include "globals.h"


//  Declare some functions
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
void HandleMenu (HWND hwnd, UINT Command);
HWND CreateStatusbar (HWND hwnd);
HWND CreateToolbar (HWND hwnd);
LRESULT CALLBACK ClientWndProc (HWND, UINT, WPARAM, LPARAM );
void Compass(void);

// Declare some globals
HWND hWndMain, hWndClient, hWndMap;
HWND hWndStatusbar, hWndToolbar;
HDC hdc, hmdc;
HBITMAP hBmp;
// size is the size of the bitmap. Will be moved to the
// options dialog later...
POINTS offset = {0,0}, size = {500,500};
HINSTANCE g_hinst;
HFONT g_hfFont;

/*-----------------------------------------------------------------
 Main Window Function
------------------------------------------------------------------*/
int WINAPI
WinMain (HINSTANCE hThisInstance,
        HINSTANCE hPrevInstance,
        LPSTR lpszArgument,
        int cmdShow)
{
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */
    HMENU hMenu;             /* Handle for the menu */
    HACCEL hAccKeys;
    char szClassName[ ] = "WindowsApp";
    char szClientName[ ] = "WindowsCli";
    char text[80];

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon (hThisInstance, MAKEINTRESOURCE (IDI_GCM));
    wincl.hIconSm = LoadIcon (hThisInstance, MAKEINTRESOURCE (IDI_GCM));
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH)  GetStockObject (GRAY_BRUSH);

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    // We need a client to paint on
      wincl.hInstance = hThisInstance;
      wincl.lpszClassName = szClientName;
      wincl.lpfnWndProc = ClientWndProc;
      wincl.style = CS_DBLCLKS;
      wincl.cbSize = sizeof (WNDCLASSEX);
      wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
      wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
      wincl.hCursor = LoadCursor (NULL, IDC_CROSS);		/* men korshrsmarkr */
      wincl.lpszMenuName = NULL;
      wincl.cbClsExtra = 0;
      wincl.cbWndExtra = 0;
      wincl.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);

      if (!RegisterClassEx (&wincl))
        return 0;

        //Load the title from a resource
        LoadString (hThisInstance, IDS_PROGTITLE, text, 79);

    /* The class is registered, let's create the program*/
    hWndMain = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           text,                /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           500,                 /* The programs width */
           400,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Load the menu */
      hMenu = LoadMenu (hThisInstance, "MAINMENU");
      SetMenu (hWndMain, hMenu);

    /* Load accelerator keys (ex. Ctrl-N) */
    hAccKeys = LoadAccelerators (hThisInstance, "IDR_ACCKEYS");

      hWndClient = CreateWindowEx (
              0,
              szClientName,
              "GcmPaint",
              WS_CHILD | WS_HSCROLL | WS_VSCROLL,
              0, 0,	/* x-, y-position */
			  100, 100, hWndMain, 0, hThisInstance, 0);

    /* Make the window visible on the screen */
    ShowWindow (hWndMain, cmdShow);
    ShowWindow (hWndClient, cmdShow);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
		if (!TranslateAccelerator(hWndMain, hAccKeys, &messages))
		{
            TranslateMessage(&messages);
            /* Send message to WindowProcedure */
            DispatchMessage(&messages);
        }
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}



/*-----------------------------------------------------------------
 Main window processing function
------------------------------------------------------------------*/
LRESULT CALLBACK
WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int iStatus[4]; // Number of fields in statusbar
    HWND hWndTT; // For tooltips
    LPTOOLTIPTEXT lpToolTipText;
    TOOLINFO lpToolInfo;
    char text[80];

    switch (message)                  /* handle the messages */
    {
        case WM_CREATE:
            hWndStatusbar = CreateStatusbar (hwnd);
            hWndToolbar = CreateToolbar (hwnd);
          hWndTT = (HWND) SendMessage (hWndToolbar, TB_GETTOOLTIPS, 0, 0);

          if (hWndTT)
          {
        	  lpToolInfo.cbSize = sizeof (lpToolInfo);
        	  lpToolInfo.uFlags = TTF_IDISHWND | TTF_CENTERTIP;
        	  lpToolInfo.lpszText = (LPSTR) text;
        	  lpToolInfo.hwnd = hwnd;
        	  lpToolInfo.uId = 0;
        	  lpToolInfo.hinst = (HINSTANCE) GetWindowLong (hwnd, GWL_HINSTANCE);

        	  SendMessage (hWndTT, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) & lpToolInfo);
            }
        InvalidateRgn (hWndToolbar, NULL, TRUE);
        break;

        case WM_COMMAND:
            HandleMenu (hwnd, LOWORD (wParam));
          break;

        case WM_SIZE:
            RECT rcFrame ,rc, rcClient;
            // get size of frame window
            GetClientRect(hwnd, &rcFrame);
            offset.x = rcClient.left = 0;
            offset.y = rcClient.top = 0;

            GetWindowRect(hWndToolbar, &rc);
            ScreenToClient(hwnd, (LPPOINT)&rc + 1);
            rcClient.top = rc.bottom;

            GetWindowRect(hWndStatusbar, &rc);
            ScreenToClient(hwnd, (LPPOINT)&rc);

            rcClient.bottom = rc.top - rcClient.top;

        MoveWindow(hWndClient,
                   rcFrame.left,
                   rcClient.top,
                   rcFrame.right,
                   rcClient.bottom,
                   TRUE);

              SendMessage (hWndStatusbar, WM_SIZE, wParam, lParam);

              iStatus[3] = -1;
              iStatus[2] = LOWORD (lParam) - 70;
              iStatus[1] = LOWORD (lParam) - 140;
              iStatus[0] = LOWORD (lParam) - 210;

              SendMessage (hWndStatusbar, SB_SETPARTS, 4, (LPARAM) iStatus);
              SendMessage (hWndStatusbar, SB_SETTEXT, 0, (LPARAM) "Field 0");
              SendMessage (hWndStatusbar, SB_SETTEXT, 1, (LPARAM) "Field 1");
              SendMessage (hWndStatusbar, SB_SETTEXT, 2, (LPARAM) "Field 2");
              SendMessage (hWndStatusbar, SB_SETTEXT, 3, (LPARAM) "Field 3");

              SendMessage (hWndToolbar, TB_AUTOSIZE, 0L, 0L);
              InvalidateRgn (hWndMain, NULL, TRUE);
              break;

        case WM_NOTIFY:
          // Show tooltips
            if ((((LPNMHDR) lParam)->code) == TTN_NEEDTEXT)
            {
    	       lpToolTipText = (LPTOOLTIPTEXT) lParam;

            	  /* load string from resource */
            	  LoadString ((HINSTANCE) GetWindowLong (hwnd, GWL_HINSTANCE),
            		      lpToolTipText->hdr.idFrom,	/* identity = command */
            		      text,	/* save in a string */
            		      sizeof (text));

            	  /* assign text to be shown in tooltips */
            	  lpToolTipText->lpszText = text;
            }
            break;

            case WM_DESTROY:
                PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
                break;
            default:                      /* for messages that we don't deal with */
                return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}

/*-----------------------------------------------------------------
 Function to handle menu selections
------------------------------------------------------------------*/
void HandleMenu (HWND hwnd, UINT Command)
{

    switch (Command)
    {
        case IDM_NEW:
        // Just to see something happen
        // Change the size of the bitmap
        size.x = 800; size.y = 800;
        SendMessage(hWndClient,WM_CREATE,0,0);
        SendMessage(hWndClient,WM_SIZE,0,0);
        break;

        case IDM_SAVEBMP:
      	  MessageBox (hWndMain, "Save Bitmap", "Menu", MB_OK | MB_ICONINFORMATION);
        break;

        case IDM_SAVEBMPAS:
      	  MessageBox (hWndMain, "Save Bitmap AS", "Menu", MB_OK | MB_ICONINFORMATION);
        break;

        case IDM_OPTIONS:
      	  MessageBox (NULL, "Options", "Menu", MB_OK | MB_ICONINFORMATION);
        break;

        case IDM_DXPOS:
      	  MessageBox (NULL, "DxPos", "Menu", MB_OK | MB_ICONINFORMATION);
        break;

        case IDM_ABOUT:
      	  MessageBox (NULL, "About", "Menu", MB_OK | MB_ICONINFORMATION);
        break;

        case IDM_HELP:
      	  MessageBox (NULL, "Help", "Menu", MB_OK | MB_ICONINFORMATION);
        break;

        case IDM_EXIT:
          PostQuitMessage (0);
        break;
    }
  return;
}

/*-----------------------------------------------------------------
 Function to create the status bar
------------------------------------------------------------------*/
HWND CreateStatusbar (HWND hwnd)
{
  HWND hWndFields;

  hWndFields = CreateStatusWindow (WS_CHILD | WS_VISIBLE |
		   CCS_ADJUSTABLE | SBARS_SIZEGRIP, NULL, hwnd, IDR_STATUS);
  return hWndFields;
}

/*-----------------------------------------------------------------
 Function to create the toolbar
------------------------------------------------------------------*/
HWND CreateToolbar (HWND hwnd)
{
  const int NUMBUTTS = 8; // Number of buttons

  TBBUTTON tbButtns[NUMBUTTS];
  HBITMAP hbPict;

  HINSTANCE hInst = (HINSTANCE) GetWindowLong (hwnd, GWL_HINSTANCE);
  int i;

  hbPict = LoadBitmap (hInst, MAKEINTRESOURCE (IDB_TOOL));

  for (i = 0; i < NUMBUTTS; i++)
    {
      tbButtns[i].idCommand = 0;
      tbButtns[i].fsState = TBSTATE_ENABLED;
//    if ((i >= 1) && (i <= 4))  // If you want to group together some btns
//	     tbButtns[i].fsStyle = TBSTYLE_BUTTON | TBSTYLE_CHECKGROUP;
//      else
	   tbButtns[i].fsStyle = TBSTYLE_BUTTON;
	   tbButtns[i].dwData = 0;
	   tbButtns[i].iString = 0;
    }

  tbButtns[0].iBitmap = 0;  // Number in bitmap
  tbButtns[0].idCommand = IDM_NEW; // Menu command
  tbButtns[1].iBitmap = 1;
  tbButtns[1].idCommand = IDM_SAVEBMP;

  tbButtns[2].iBitmap = -1; // Separator
  tbButtns[2].fsStyle = TBSTYLE_SEP;

  tbButtns[3].iBitmap = 3;
  tbButtns[3].idCommand = IDM_EXIT;
  tbButtns[4].iBitmap = 4;
  tbButtns[4].idCommand = IDM_OPTIONS;
  tbButtns[5].iBitmap = 5;
  tbButtns[5].idCommand = IDM_DXPOS;

  tbButtns[6].iBitmap = -1; // Separator
  tbButtns[6].fsStyle = TBSTYLE_SEP;

  tbButtns[7].iBitmap = 6;
  tbButtns[7].idCommand = IDM_HELP;


  // buttons and icons 16x16 pixels
  return CreateToolbarEx (hwnd, WS_CHILD | WS_VISIBLE | TBSTYLE_TOOLTIPS, IDR_TOOLB,
            NUMBUTTS, NULL, (UINT) hbPict, tbButtns, NUMBUTTS, 16, 16,
            16, 16, sizeof (TBBUTTON));
}

/*-----------------------------------------------------------------
 Message process for the Client Window
------------------------------------------------------------------*/
LRESULT CALLBACK
ClientWndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT drawStruct;
    HDC hdcWmPaint;
    static int iMaxX, iMaxY;
    SCROLLINFO si;
    RECT dArea;
    HFONT hfOld;

  switch (message)
    {
    case WM_ERASEBKGND: // remove flicker
            return 0;
       break;

    case WM_CREATE:
        if(hBmp){
            DeleteObject(hBmp);
            hBmp = NULL;
        }
            // Load a nice gui font
            g_hfFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);

            // Size of the screen
              iMaxX = GetSystemMetrics (SM_CXSCREEN);
              iMaxY = GetSystemMetrics (SM_CYSCREEN);

            // Create a writable surface
          hdc = GetDC (hwnd);
          hmdc = CreateCompatibleDC (hdc);
          hBmp = CreateCompatibleBitmap (hdc, size.x, size.y);

          SelectObject (hmdc, hBmp);

// If you want to set another background color - do it here
// SelectObject (hmdc, CreateSolidBrush (RGB(100,250,100)));

          PatBlt (hmdc, 0, 0, size.x, size.y, PATCOPY);
          ReleaseDC (hwnd, hdc);

          // Make a compass with degree marks
          Compass();

      break;

    case WM_PAINT:
          hdcWmPaint = BeginPaint (hwnd, &drawStruct);

	       hfOld = (HFONT)SelectObject(hdcWmPaint, g_hfFont);
            BitBlt (hdcWmPaint, 0, 0, iMaxX, iMaxY, hmdc, offset.x, offset.y, SRCCOPY);
    	   SelectObject(hdcWmPaint, hfOld);

          EndPaint (hwnd, &drawStruct);
      break;

    case WM_SIZE:
          GetClientRect (hWndClient, &dArea);

          // Common for both hor and vert scrollbar
          si.cbSize = sizeof (SCROLLINFO);
          si.fMask = SIF_PAGE | SIF_RANGE | SIF_POS;
          si.nMin = 0;

          // Hor specific
          si.nMax = size.x - 1;
          si.nPage = dArea.right - dArea.left;
          si.nPos = offset.x;
          SetScrollInfo (hWndClient, SB_HORZ, &si, TRUE);

          // Vert Specific
          si.nMax = size.y - 1;
          si.nPage = dArea.bottom - dArea.top;
          si.nPos = offset.y;
          SetScrollInfo (hWndClient, SB_VERT, &si, TRUE);

          InvalidateRgn (hWndClient, NULL, TRUE);
      break;

    case WM_HSCROLL:
          si.cbSize = sizeof (SCROLLINFO);
          GetClientRect (hWndClient, &dArea);

          switch (LOWORD (wParam))
          {
            	case SB_PAGEUP: // Large step
            	  offset.x -= 100;
            	  break;

            	case SB_PAGEDOWN:
            	  offset.x += 100;
            	  break;

            	case SB_LINEUP: // small Step
            	  offset.x -= 20;
            	  break;

            	case SB_LINEDOWN:
            	  offset.x += 20;
            	  break;

            	case SB_THUMBTRACK:
            	case SB_THUMBPOSITION:
            	  offset.x = HIWORD (wParam);
            	  break;

    	  }
    	  // Here we check if we are "out of range" for the
    	  // scrollrange and adjust properly
    	  if(offset.x < 0) offset.x = 0;
    	  if(offset.x > size.x - dArea.right) offset.x = size.x - dArea.right;

    	  si.fMask = SIF_PAGE | SIF_RANGE | SIF_POS;
    	  si.nMin = 0;
    	  si.nMax = size.x;
    	  si.nPage = dArea.right;
    	  si.nPos = offset.x;
          SetScrollInfo (hWndClient, SB_HORZ, &si, TRUE);
          InvalidateRgn (hWndClient, NULL, TRUE);
          break;

    case WM_VSCROLL:
          si.cbSize = sizeof (SCROLLINFO);
          GetClientRect (hWndClient, &dArea);

          switch (LOWORD (wParam))
          {
            	case SB_PAGEUP:
            	  offset.y -= 100;
            	  break;

            	case SB_PAGEDOWN:
            	  offset.y += 100;
            	  break;

            	case SB_LINEUP:
            	  offset.y -= 20;
            	  break;

            	case SB_LINEDOWN:
            	  offset.y += 20;
            	  break;

            	case SB_THUMBTRACK:
            	case SB_THUMBPOSITION:
            	  offset.y = HIWORD (wParam);
            	  break;

    	  }
    	  // Here we check if we are "out of range" for the
    	  // scrollrange and adjust properly
    	  if(offset.y < 0) offset.y = 0;
    	  if(offset.y > size.y - dArea.bottom) offset.y = size.y - dArea.bottom;

    	  si.fMask = SIF_PAGE | SIF_RANGE | SIF_POS;
    	  si.nMin = 0;
    	  si.nMax = size.y;
    	  si.nPage = dArea.bottom;
    	  si.nPos = offset.y;
          SetScrollInfo (hWndClient, SB_VERT, &si, TRUE);
          InvalidateRgn (hWndClient, NULL, TRUE);
          break;

    case WM_DESTROY:
          PostQuitMessage (0);
      break;

    default:
      return DefWindowProc (hwnd, message, wParam, lParam);
    }
  return 0;
}

/*-----------------------------------------------------------------
 Function to draw a compass and degree marks around the edge
------------------------------------------------------------------*/
/* TODO (roger#1#): Algoritm for making the font size and compass width
                    automatic */
void Compass(void)
{
    HPEN dPen;
	HFONT hfFont;
	LOGFONT lf;
	int linelength, widthToEdge = 15,widthOfRing = 6,step = 10,marks;
	int halfx = size.x / 2;
	int halfy = size.y / 2;
    double deg, pos, SHdim, SVdim;
	char buf[5];

      dPen = CreatePen (PS_SOLID, 1, RGB(0,0,0));
	  SelectObject (hmdc, dPen);

	  // Outer ring
	  Ellipse(hmdc,
            widthToEdge,
            widthToEdge,
            size.x - widthToEdge,
            size.y - widthToEdge);

	  // Inner ring
      Ellipse(hmdc,
            widthOfRing + widthToEdge,
            widthOfRing + widthToEdge,
            size.x - widthOfRing - widthToEdge,
            size.y - widthOfRing - widthToEdge);

	//The compass and degree marks
	for(marks = 0; marks < 360; marks++)
	{
		 deg = marks * D2R;
  		 	if(marks % step)  //A longer line every step degree
  		 	      linelength = widthOfRing;
   			else
   			      linelength = (int)(widthOfRing * 2);

        MoveToEx(hmdc,(int)((halfx+sin(deg) * (halfx-widthToEdge))+.5),
                (int)((halfy-cos(deg) * (halfy-widthToEdge))+.5),NULL);
        LineTo(hmdc,(int)((halfx+sin(deg) * (halfx-linelength-widthToEdge))+.5),
                (int)((halfy-cos(deg) * (halfy-linelength-widthToEdge))+.5));
        MoveToEx(hmdc,(int)((((size.x/2)+sin(deg) * ((size.x/2)-widthToEdge)))+.5),
                (int)(((size.y/2)-cos(deg) * ((size.y/2)-widthToEdge))+.5),NULL);
        LineTo(hmdc,(int)((((size.x/2)+sin(deg) * ((size.x/2-linelength)-widthToEdge)))+.5),
                (int)(((size.y/2)-cos(deg) * ((size.y/2-linelength)-widthToEdge))+.5));
	}

	// This is how to get a font and rotate it!
	// Look in the Win32 help file for LOGFONT
	hfFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	GetObject(hfFont, sizeof(LOGFONT), &lf);
    lf.lfEscapement = -900;
    lf.lfOrientation = -900;
    SelectObject (hmdc, hfFont);
    SetTextAlign(hmdc,TA_CENTER);
	SetBkMode(hmdc, TRANSPARENT);

  	for(pos = 0; pos < 360; pos += step)
  	{
        	sprintf(buf,"%.0f", pos);  //Hope you dont want this in radians
            deg = pos * D2R;

        SHdim = (halfx + (sin(deg) * halfx));
        SVdim = (halfy - (cos(deg) * halfy));

        lf.lfEscapement = (LONG) -pos * 10;
        lf.lfOrientation = (LONG)-pos * 10;
        hfFont = CreateFontIndirect(&lf);

        SelectObject (hmdc, hfFont);
      	TextOut(hmdc, (int)SHdim, (int)SVdim, buf, lstrlen(buf));
    }

}


